<template>
  <div class="measure" id="measure">
    <div class="tool-title">
      <!-- <img src="@/assets/img/right/head.png" /> -->
      <label>量测</label>
    </div>
    <hr />
    <div class="measureTools">
      <div
        :class="isOpen['jl'] ? 'measureTool active' : 'measureTool'"
        @click="jl"
      >
        <el-button>
          <img src="@/assets/img/right/ls/jl1.png" />
          <label>距离</label>
        </el-button>
      </div>
      <div
        :class="isOpen['bmjl'] ? 'measureTool active' : 'measureTool'"
        @click="bmjl"
      >
        <el-button>
          <img src="@/assets/img/right/ls/bmjl1.png" />
          <label>表面距离</label>
        </el-button>
      </div>
      <div
        :class="isOpen['mj'] ? 'measureTool active' : 'measureTool'"
        @click="mj"
      >
        <el-button>
          <img src="@/assets/img/right/ls/mj1.png" />
          <label>面积</label>
        </el-button>
      </div>
      <div
        :class="isOpen['bmmj'] ? 'measureTool active' : 'measureTool'"
        @click="bmmj"
      >
        <el-button>
          <img src="@/assets/img/right/ls/bmmj1.png" />
          <label>表面面积</label>
        </el-button>
      </div>
      <div
        :class="isOpen['czgd'] ? 'measureTool active' : 'measureTool'"
        @click="height"
      >
        <el-button>
          <img src="@/assets/img/right/ls/gd1.png" />
          <label>垂直高度</label>
        </el-button>
      </div>
      <!-- <div
        :class="isOpen['tj'] ? 'measureTool active' : 'measureTool'"
        @click="tj"
      >
        <el-button>
          <img src="@/assets/img/right/ls/tj1.png" />
          <label>体积</label>
        </el-button>
      </div> -->
      <div
        :class="isOpen['jd'] ? 'measureTool active' : 'measureTool'"
        @click="jd"
      >
        <el-button>
          <img src="@/assets/img/right/ls/jd1.png" />
          <label>角度</label>
        </el-button>
      </div>
      <div class="measureTool" @click="clearMeasure">
        <el-button>
          <img src="@/assets/img/right/ls/qc-s.png" />
          <label>清除</label>
        </el-button>
      </div>
      <div class="measureTool" @click="clearMeasure">
        <el-button>
     
          <label></label>
        </el-button>
      </div>
    </div>
    <!-- <div class="closeTool" title="收缩" @click="close">
      <el-button>
        <img src="@/assets/img/right/ss.png" />
      </el-button>
    </div> -->
  </div>
</template>

<style scoped>
hr {
  margin: 10px 0;
  width: 111%;
  margin-left: -15px;
}
.el-button:focus,
.el-button:hover {
  background: transparent;
}
.measure {
  width: 270px;
  height: 365px;
}
.measureTool {
  padding: 5px 0;
  padding-left: 35px;
}
.measureTools {
  height: 270px;
  overflow-y: auto;
}
.measureTools::-webkit-scrollbar {
  /*滚动条整体样式*/
  width: 5px;
  /*高宽分别对应横竖滚动条的尺寸*/
  height: 8px;
  scrollbar-arrow-color: red;
}

/* 滚动条 */
.measureTools::-webkit-scrollbar-thumb {
  border-radius: 5px;
  -webkit-box-shadow: inset 0 0 5px rgba(218, 218, 218, 0.2);
  box-shadow: inset 0 0 5px rgba(218, 218, 218, 0.2);
  background: rgba(218, 218, 218, 0.5);
  scrollbar-arrow-color: red;
}

/* 滚动槽 */
.measureTools::-webkit-scrollbar-track {
  -webkit-box-shadow: inset 0 0 5px rgba(218, 218, 218, 0.2);
  box-shadow: inset 0 0 5px rgba(218, 218, 218, 0.2);
  border-radius: 0;
  background: rgba(218, 218, 218, 0.1);
}
.measureTool:hover {
  background: rgba(0, 168, 255, 0.16);
}

.tool-title {
  margin: 1px 10px;
}
.tool-title label {
  vertical-align: top;
}
.measure label {
  margin-left: 10px;
  font-size: 17px;
  font-family: Microsoft YaHei;
  font-weight: 400;
  /* color: #3d3d3d; */
  color: white;
}
.el-button {
  padding: 0 !important;
  font-size: 24px;
  border: unset;
  float: unset;
  display: block;
  background: rgba(0, 0, 0, 0);
}
.el-button label {
  font-size: 14px;
}
.closeTool {
  position: absolute;
  bottom: 0;
  left: 0;
}
.active {
  background: rgba(0, 168, 255, 0.16);
}
</style>
    
<script>
let measureData = [];
let volumetricMeasurementTool = undefined;
let colorAll = {
  point: Cesium.Color.fromCssColorString("#ff0000"),
  polyline: Cesium.Color.fromCssColorString("#ffff0050"),
  polygon: Cesium.Color.fromCssColorString("#ffff0050"),
};

export default {
  name: "measure",
  data() {
    return {
      status: false,
      isOpen: {
        jl: false,
        bmjl: false,
        mj: false,
        bmmj: false,
        tj: false,
        czgd: false,
        jd: false,
      },
    };
  },
  mounted() {},
  methods: {
    // 清除高亮
    clearActive() {
      this.isOpen.jl = false;
      this.isOpen.bmjl = false;
      this.isOpen.mj = false;
      this.isOpen.bmmj = false;
      this.isOpen.tj = false;
      this.isOpen.czgd = false;
      this.isOpen.jd = false;
    },
    //关闭窗口
    close() {
      this.$parent.isShowMeasure = false;
      this.$parent.isShow = false;
    },
    //清除测量
    clearMeasure() {
      // 关闭当前的操作界面
      //this.$parent.$parent.$parent.closeAll();
      measureData.forEach((item) => {
        item.deleteObject();
      });
      measureData = [];

      volumetricMeasurementTool && volumetricMeasurementTool.cleanUp();
    },
    // 距离量算
    jl() {
      this.$parent.$parent.$parent.closeAllHighLight("measure");
      if (this.isOpen["jl"]) {
        this.isOpen["jl"] = false;
        sgworld.drawObj && sgworld.drawObj.end && sgworld.drawObj.end("cancel");
        return;
      }
      // 清除所有的高亮状态
      this.clearActive();

      // 关闭当前的操作界面
      //this.$parent.$parent.$parent.closeAll();
      //结束上一次操作
      layuiLayer.close(SmartEarthPopupData.layerProp);
      sgworld.drawObj &&
        (sgworld.drawObj.drawHandler && sgworld.drawObj.drawHandler.destroy(),
        sgworld.drawObj.end && sgworld.drawObj.end());

      // 根据当前的高亮状态，决定当前操作是否要显示高亮
      this.isOpen["jl"] = true;
      let m = sgworld.Command.execute(0, 10, colorAll, () => {
        sgworld.drawObj = undefined;
        this.isOpen["jl"] = false;
      });
      sgworld.drawObj = m;
      measureData.push(m);
    },
    // 表面距离
    bmjl: function () {
      this.$parent.$parent.$parent.closeAllHighLight("measure");
      if (this.isOpen["bmjl"]) {
        this.isOpen["bmjl"] = false;
        sgworld.drawObj && sgworld.drawObj.end && sgworld.drawObj.end("cancel");
        return;
      }
      // 清除所有的高亮状态
      this.clearActive();
      // 根据当前的高亮状态，决定当前操作是否要显示高亮
      // 关闭当前的操作界面
      //this.$parent.$parent.$parent.closeAll();
      //结束上一次操作
      layuiLayer.close(SmartEarthPopupData.layerProp);
      sgworld.drawObj &&
        (sgworld.drawObj.drawHandler && sgworld.drawObj.drawHandler.destroy(),
        sgworld.drawObj.end && sgworld.drawObj.end());

      this.isOpen["bmjl"] = true;

      let m = sgworld.Command.execute(0, 2, colorAll, () => {
        sgworld.drawObj = undefined;
        this.isOpen["bmjl"] = false;
      });
      sgworld.drawObj = m;
      measureData.push(m);
    },
    // 表面面积
    bmmj: function () {
      this.$parent.$parent.$parent.closeAllHighLight("measure");
      if (this.isOpen["bmmj"]) {
        this.isOpen["bmmj"] = false;
        sgworld.drawObj && sgworld.drawObj.end && sgworld.drawObj.end("cancel");
        return;
      }
      // 清除所有的高亮状态
      this.clearActive();

      // 关闭当前的操作界面
      //this.$parent.$parent.$parent.closeAll();
      //结束上一次操作
      layuiLayer.close(SmartEarthPopupData.layerProp);
      sgworld.drawObj &&
        (sgworld.drawObj.drawHandler && sgworld.drawObj.drawHandler.destroy(),
        sgworld.drawObj.end && sgworld.drawObj.end());

      this.isOpen["bmmj"] = true;
      let m = sgworld.Command.execute(0, 8, colorAll, () => {
        sgworld.drawObj = undefined;
        this.isOpen["bmmj"] = false;
      });
      sgworld.drawObj = m;
      measureData.push(m);
    },
    // 面积
    mj: function () {
      this.$parent.$parent.$parent.closeAllHighLight("measure");
      if (this.isOpen["mj"]) {
        this.isOpen["mj"] = false;
        sgworld.drawObj && sgworld.drawObj.end && sgworld.drawObj.end("cancel");
        return;
      }
      // 清除所有的高亮状态
      this.clearActive();
      // 根据当前的高亮状态，决定当前操作是否要显示高亮
      // 关闭当前的操作界面
      //this.$parent.$parent.$parent.closeAll();
      //结束上一次操作
      layuiLayer.close(SmartEarthPopupData.layerProp);
      sgworld.drawObj &&
        (sgworld.drawObj.drawHandler && sgworld.drawObj.drawHandler.destroy(),
        sgworld.drawObj.end && sgworld.drawObj.end());

      this.isOpen["mj"] = true;

      let m = sgworld.Command.execute(0, 3, colorAll, () => {
        sgworld.drawObj = undefined;
        this.isOpen["mj"] = false;
      });
      sgworld.drawObj = m;
      measureData.push(m);
    },
    // 角度量算
    jd() {
      this.$parent.$parent.$parent.closeAll();

      if (this.isOpen["jd"]) {
        this.isOpen["jd"] = false;
        sgworld.drawObj && sgworld.drawObj.end && sgworld.drawObj.end("cancel");
        return;
      }
      // 清除所有的高亮状态
      this.clearActive();
      // 根据当前的高亮状态，决定当前操作是否要显示高亮
      // 关闭当前的操作界面
      //结束上一次操作
      layuiLayer.close(SmartEarthPopupData.layerProp);
      sgworld.drawObj &&
        (sgworld.drawObj.drawHandler && sgworld.drawObj.drawHandler.destroy(),
        sgworld.drawObj.end && sgworld.drawObj.end());

      this.isOpen["jd"] = true;

      let m = sgworld.Command.execute(0, 12, colorAll, () => {
        sgworld.drawObj = undefined;
        this.isOpen["jd"] = false;
      });
      sgworld.drawObj = m;
      measureData.push(m);
    },
    height() {
      this.$parent.$parent.$parent.closeAllHighLight("measure");
      if (this.isOpen["czgd"]) {
        this.isOpen["czgd"] = false;
        sgworld.drawObj && sgworld.drawObj.end && sgworld.drawObj.end("cancel");
        return;
      }
      // 清除所有的高亮状态
      this.clearActive();
      // 根据当前的高亮状态，决定当前操作是否要显示高亮
      // 关闭当前的操作界面
      //this.$parent.$parent.$parent.closeAll();
      //结束上一次操作
      layuiLayer.close(SmartEarthPopupData.layerProp);
      sgworld.drawObj &&
        (sgworld.drawObj.drawHandler && sgworld.drawObj.drawHandler.destroy(),
        sgworld.drawObj.end && sgworld.drawObj.end());

      this.isOpen["czgd"] = true;

      let m = sgworld.Command.execute(0, 5, colorAll, () => {
        sgworld.drawObj = undefined;
        this.isOpen["czgd"] = false;
      });
      sgworld.drawObj = m;
      measureData.push(m);
    },
    // 体积
    tj() {
      this.$parent.$parent.$parent.closeAllHighLight("measure");
      if (this.isOpen["tj"]) {
        this.isOpen["tj"] = false;
        sgworld.drawObj && sgworld.drawObj.end && sgworld.drawObj.end("cancel");
        return;
      }
      // 清除所有的高亮状态
      this.clearActive();
      // 根据当前的高亮状态，决定当前操作是否要显示高亮
      // 关闭当前的操作界面
      //this.$parent.$parent.$parent.closeAll();
      //结束上一次操作
      layuiLayer.close(SmartEarthPopupData.layerProp);
      sgworld.drawObj &&
        (sgworld.drawObj.drawHandler && sgworld.drawObj.drawHandler.destroy(),
        sgworld.drawObj.end && sgworld.drawObj.end());

      this.isOpen["tj"] = true;

      //体积方量
      function Volumetric(spacing, callback) {
        if (!volumetricMeasurementTool) {
          volumetricMeasurementTool = sgworld.Creator.createVolumetricMeasureTool();
        }

        sgworld.drawObj = volumetricMeasurementTool.startDrawing(
          null,
          spacing,
          function (data) {
            callback &&
              typeof callback === "function" &&
              callback({ height: data.minHeight, spacing: data.spacing });
          }
        );
      }

      Volumetric("auto", (data) => {
        this.isOpen["tj"] = false;
      });
    },
  },
  beforeDestroy(){
    //this.clearMeasure();
  }
};
</script>